#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const int inf = 1e9;


vector<set<pair<int, ll>>> g;
vector<unordered_map<int, ll>> edge;
unordered_set<int> all;
vector<bool> used, can;

void dijksta(int v, int h) {
    int v1 = v;
    unordered_map<int, ll> d;
    for (int ma: all) {
        d[ma] = inf;
    }
    set<pair<ll, int>> q;
    q.insert({0, v});
    d[v] = 0;
    while (!q.empty()) {
        v = q.begin()->second;
        q.erase({d[v], v});
        for (auto [u, w]: g[v]) {
            if (d[u] > d[v] + w) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    for (auto [a, b]: d) {
        if (b <= h && (a == v1 || !can[a])) {
            all.erase(a);
            for (auto [u1, w1]: g[a]) {
                for (auto [u2, w2]: g[a]) {
                    if (edge[u1][u2] > w1 + w2) {
                        g[u1].erase({u2, edge[u1][u2]});
                        g[u2].erase({u1, edge[u1][u2]});
                        g[u1].insert({u2, w1 + w2});
                        g[u2].insert({u1, w1 + w2});
                        edge[u1][u2] = w1 + w2;
                        edge[u2][u1] = w1 + w2;
                    }
                }
            }
            g[a].clear();
            used[a] = true;
        }
    }
}

bool comp(pair<int, int> o1, pair<int, int> o2) {
    return o1.second > o2.second;
}

signed main() {
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    edge.resize(n);
    vector<pair<int, int>> o(k);
    for (int i = 0; i < n; i++) {
        all.insert(i);
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        g[u - 1].insert({v - 1, 1});
        g[v - 1].insert({u - 1, 1});
        edge[u - 1][v - 1] = 1;
        edge[v - 1][u - 1] = 1;
    }
    can.assign(n, false);
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        can[p - 1] = true;
        o[i].first = p - 1, o[i].second = h;
    }
    sort(o.begin(), o.end(), comp);
    used.assign(n, false);
    for (int i = 0; i < int(o.size()); i++) {
        dijksta(o[i].first, o[i].second);
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans.push_back(i);
        }
    }
    cout << int(ans.size()) << "\n";
    for (int ma: ans) {
        cout << (ma + 1) << " ";
    }
}